
// LA_SDK_CallerDlg.cpp : @
//

#include "stdafx.h"
#include "LA_SDK_Caller.h"
#include "LA_SDK_CallerDlg.h"
#include "LArun.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define ID_TM_CAPTURE 150

// CLA_SDK_CallerDlg ܤ

CLA_SDK_CallerDlg::CLA_SDK_CallerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLA_SDK_CallerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pDev1Data = NULL;
	m_pDev2Data = NULL;
	m_iDev1DataLength = 0;
	m_iDev2DataLength = 0;
}
CLA_SDK_CallerDlg::~CLA_SDK_CallerDlg()
{
	if (m_pDev1Data != NULL)
		delete m_pDev1Data;
	if (m_pDev2Data != NULL)
		delete m_pDev2Data;
}

void CLA_SDK_CallerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CLA_SDK_CallerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CLA_SDK_CallerDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON1, &CLA_SDK_CallerDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CLA_SDK_CallerDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CLA_SDK_CallerDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CLA_SDK_CallerDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CLA_SDK_CallerDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CLA_SDK_CallerDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CLA_SDK_CallerDlg::OnBnClickedButton7)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON8, &CLA_SDK_CallerDlg::QuickGoThrough)
	ON_BN_CLICKED(IDC_BN_STOP, &CLA_SDK_CallerDlg::OnBnClickedBnStop)
	ON_BN_CLICKED(IDC_BUTTON9, &CLA_SDK_CallerDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, &CLA_SDK_CallerDlg::OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, &CLA_SDK_CallerDlg::OnBnClickedButton11)
END_MESSAGE_MAP()


// CLA_SDK_CallerDlg TBz`

BOOL CLA_SDK_CallerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	this->SetDlgItemTextA(IDC_ED_THRESHOLD, "1600");
	this->SetDlgItemInt(IDC_ED_HWINFO, 500);	
	this->SetDlgItemTextA(IDC_ED_THRESHOLD2, "1600");
	this->SetDlgItemInt(IDC_ED_HWINFO2, 500);	
	CRect rcRect, rcMainWnd;
	this->GetDlgItem(IDC_ST_WAV)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV)->SetWindowPos(this, 0, 0, 500, rcRect.Height(), SWP_NOZORDER | SWP_NOMOVE);
	this->GetDlgItem(IDC_ST_WAV2)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV2)->SetWindowPos(this, 0, 0, 500, rcRect.Height(), SWP_NOZORDER | SWP_NOMOVE);
	this->GetDlgItem(IDC_ST_WAV2)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV2)->MapWindowPoints(this, rcRect);
	this->GetWindowRect(rcMainWnd);
	rcMainWnd.right = rcRect.right + 30;
	this->MoveWindow(rcMainWnd);
	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

void CLA_SDK_CallerDlg::DrawWave(CDC* pdc, UINT * pData, int iDataLength, UINT uID_Rect)
{
	CRect rcWave;
	this->GetDlgItem(uID_Rect)->GetClientRect(rcWave);
	this->GetDlgItem(uID_Rect)->MapWindowPoints(this,rcWave);
	rcWave.InflateRect( 2, 2 );
	pdc->DrawEdge( LPRECT(rcWave), EDGE_ETCHED, BF_RECT );
	rcWave.DeflateRect( 2, 2 );

	if( iDataLength <= 0 || pData == NULL)
	{
		return;
	}
	else
	{
		int		iIndex, iCnt, iCh;
		int		iH = rcWave.Height() / 9;
		int		iGap = 5;
		POINT	*ptPoly;

		ptPoly = new POINT [1000];

		// Draw CH0..CH7
		for( iCh = 0 ; iCh < 8 ; iCh++ )
		{
			for( iIndex = 0, iCnt = 0 ; iIndex < rcWave.Width() && iIndex < iDataLength; iIndex++ )
			{
				int iCurValue = (pData[iIndex] >> iCh) & 0x01;
				int iPreValue = 0;
				if (iIndex != 0)
					iPreValue = (pData[iIndex - 1] >> iCh) & 0x01;
				if( iIndex == 0 )
				{
					(ptPoly+iCnt)->x = 0;
					if(iCurValue) 
						(ptPoly+iCnt)->y = iCh * iH + iGap;
					else
						(ptPoly+iCnt)->y = ( iCh + 1 ) * iH - iGap;
					iCnt++;
					continue;
				}
				if( iPreValue && iCurValue )
				{
					(ptPoly+iCnt)->x = iIndex;
					(ptPoly+iCnt)->y = iCh * iH + iGap;
				}
				else if( iPreValue == 0 && iCurValue )
				{
					(ptPoly+iCnt)->x = iIndex;					//	Signal	0	1	1
					(ptPoly+iCnt)->y = (iCh + 1) * iH - iGap;	//				o	o
					iCnt++;										//			o	x<------Add one point at rising edge		
					(ptPoly+iCnt)->x = iIndex;					
					(ptPoly+iCnt)->y = iCh * iH + iGap;			
				}
				else if( iPreValue && iCurValue == 0)
				{
					(ptPoly+iCnt)->x = iIndex;					//	Signal	1	0	0
					(ptPoly+iCnt)->y = iCh * iH + iGap;			//			o	x<------Add one point at falling edge	
					iCnt++;										//				o	o
					(ptPoly+iCnt)->x = iIndex;					
					(ptPoly+iCnt)->y = ( iCh + 1 ) * iH - iGap;	
				}
				else
				{
					(ptPoly+iCnt)->x = iIndex;
					(ptPoly+iCnt)->y = ( iCh + 1 ) * iH - iGap;
				}
				iCnt++;
			}
			this->GetDlgItem(uID_Rect)->MapWindowPoints(this, ptPoly, iCnt);
			pdc->Polyline( ptPoly, iCnt );
		}
		delete [] ptPoly;
	}
}

void CLA_SDK_CallerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); 
		DrawWave(&dc, m_pDev1Data, m_iDev1DataLength, IDC_ST_WAV);
		DrawWave(&dc, m_pDev2Data, m_iDev2DataLength, IDC_ST_WAV2);
		CDialog::OnPaint();
	}
}

HCURSOR CLA_SDK_CallerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CLA_SDK_CallerDlg::OnBnClickedOk()
{
	QuickGoThrough();
}

void CLA_SDK_CallerDlg::OnBnClickedButton1()
{
	if (!ulaSDKInit())		//This function will initialize all LA devices connected on the PC//
	{
		AfxMessageBox("Initial Fail");
	}
}

void CLA_SDK_CallerDlg::OnBnClickedButton2()
{
	char szBuf[70] = {0};
	char szText[256] = {0};
	char szTmp[50] = {0};
	ulaSDKSelectDeviceIdx(0);		//ulaSDKSelectDevice("TL22360000");
	ulaSDKGetSerialNumber(szTmp, 50);
	sprintf(szText, "%x\n%s\n", ulaSDKGetLaID(), szTmp);	

	if (ulaSDKSelectDeviceIdx(1))	//ulaSDKSelectDevice("TL22360001");
	{
		ulaSDKGetSerialNumber(szTmp, 50);
		sprintf(szBuf, "%x\n%s", ulaSDKGetLaID(), szTmp);	
	}
	
	strcat_s(szText, sizeof(szText), szBuf);
	AfxMessageBox(szText);
}

void CLA_SDK_CallerDlg::OnClose()
{	
	ulaSDKClose();		//This function will close all LA devices' connection//
	CDialog::OnClose();
}

void CLA_SDK_CallerDlg::OnBnClickedButton3()
{
	int iHwMode1 = this->GetDlgItemInt(IDC_ED_HWINFO);	
	int iHwMode2 = this->GetDlgItemInt(IDC_ED_HWINFO2);	
	ulaSDKSelectDeviceIdx(0);	//ulaSDKSelectDevice("TL22360000");
	if (!ulaSDKSetHwInfo(SET_TL_MODE, &iHwMode1))
		AfxMessageBox("Hw Info1 Set Error!");
	ulaSDKSelectDeviceIdx(1);	//ulaSDKSelectDevice("TL22360001");
	if (!ulaSDKSetHwInfo(SET_TL_MODE, &iHwMode2))
		AfxMessageBox("Hw Info2 Set Error!");
}

void CLA_SDK_CallerDlg::OnBnClickedButton4()
{
	int iThreshold1 = this->GetDlgItemInt(IDC_ED_THRESHOLD);
	int iThreshold2 = this->GetDlgItemInt(IDC_ED_THRESHOLD);
	ulaSDKSelectDeviceIdx(0);	//ulaSDKSelectDevice("TL22360000");
	if (!ulaSDKThreshold(0, iThreshold1))
		AfxMessageBox("Threshould1 set Error!");

	ulaSDKSelectDeviceIdx(1);	//ulaSDKSelectDevice("TL22360001");
	if (!ulaSDKThreshold(0, iThreshold2))
		AfxMessageBox("Threshould2 set Error!");
}

void CLA_SDK_CallerDlg::OnBnClickedButton5()		
{									//Device number independent trigger parameters setting.
	const int iTrigCondLevel = 0;
	const int iTrigCh_Dev1 = 0;
	const int iTrigType = LA_TRIG_RISING;
	bool	fDev1SetOK = false;
	bool	fDev2SetOK = false;
	if (ulaSDKClearTrigger(&m_SDKTrigSet1))
	{
		if (ulaSDKSetChTrigger(&m_SDKTrigSet1, iTrigCondLevel, iTrigCh_Dev1,  iTrigType, TR_NEXTIF))
		{
			m_SDKTrigSet1.iFlag = TR_PRETRIG;
			m_SDKTrigSet1.iFreq = (INT)100E6;	//100MHz
			m_SDKTrigSet1.iTrPos = 100;
			fDev1SetOK = true;	
		}
	}

	const int iTrigCondLevel2 = 0;
	const int iTrigCh_Dev2 = 1;
	const int iTrigType2 = LA_TRIG_FALLING;
	if (ulaSDKClearTrigger(&m_SDKTrigSet2))
	{
		if (ulaSDKSetChTrigger(&m_SDKTrigSet2, iTrigCondLevel2, iTrigCh_Dev2,  iTrigType2, TR_NEXTIF))
		{
			m_SDKTrigSet2.iFlag = TR_PRETRIG;
			m_SDKTrigSet2.iFreq = (INT)100E6;	//100MHz
			m_SDKTrigSet2.iTrPos = 100;
			fDev2SetOK = true;	
		}
	}
	if (!fDev1SetOK || !fDev2SetOK)
		AfxMessageBox("Trigger Set Build Error!");
}

void CLA_SDK_CallerDlg::OnBnClickedButton6()
{
	int iMaxSampleNum = ulaSDKGetMaxSamplesNum();
	int iCurCaptureNum = 500;
	if (iCurCaptureNum > iMaxSampleNum)
		iCurCaptureNum = iMaxSampleNum;
	ulaSDKSelectDeviceIdx(0);	//ulaSDKSelectDevice("TL22360000");	
	if (!ulaSDKSetSamplesNum(iCurCaptureNum))
		AfxMessageBox("Dev 1 Sample Num Set Error!");

	ulaSDKSelectDeviceIdx(1);	//ulaSDKSelectDevice("TL22360001");	
	if (!ulaSDKSetSamplesNum(iCurCaptureNum))
		AfxMessageBox("Dev 2 Sample Num Set Error!");
}

void CLA_SDK_CallerDlg::OnBnClickedButton7()
{
	ulaSDKSelectDeviceIdx(0);	//ulaSDKSelectDevice("TL22360000");	
	bool fResultOK = !!ulaSDKCapture(&m_SDKTrigSet1);

	ulaSDKSelectDeviceIdx(1);	//ulaSDKSelectDevice("TL22360001");	
	fResultOK &= !!ulaSDKCapture(&m_SDKTrigSet2);
	if (!fResultOK)
		AfxMessageBox("Capture Error!");
	else
	{
		this->GetDlgItem(IDC_BUTTON8)->EnableWindow(false);
		this->GetDlgItem(IDC_BUTTON7)->EnableWindow(false);
		this->GetDlgItem(IDC_BN_STOP)->EnableWindow(true);
		SetTimer(ID_TM_CAPTURE, 100, NULL);
	}
}

void CLA_SDK_CallerDlg::OnTimer(UINT_PTR nIDEvent)
{
	ulaSDKSelectDeviceIdx(0);	//ulaSDKSelectDevice("TL22360000");	
	bool fResult = !!ulaSDKIsCaptureReady();
	ulaSDKSelectDeviceIdx(1);	//ulaSDKSelectDevice("TL22360001");	
	fResult &= !!ulaSDKIsCaptureReady();

	if (fResult)
	{
		KillTimer(ID_TM_CAPTURE);
		ShowDataOnList();
		this->GetDlgItem(IDC_BUTTON8)->EnableWindow(true);
		this->GetDlgItem(IDC_BUTTON7)->EnableWindow(true);
		this->GetDlgItem(IDC_BN_STOP)->EnableWindow(false);
	}
	CDialog::OnTimer(nIDEvent);
}

bool CLA_SDK_CallerDlg::GetWaveData(int iDevIdx)
{
	UINT** puiData[] = {&m_pDev1Data, &m_pDev2Data};
	int* puiSize[] = {&m_iDev1DataLength, &m_iDev2DataLength};

	ulaSDKSelectDeviceIdx(iDevIdx);	//ulaSDKSelectDevice("TL22360000");	
	*puiSize[iDevIdx] = ulaSDKGetSamplesNum();
	if (*puiData[iDevIdx] != NULL)
	{
		delete *puiData[iDevIdx];
		*puiData[iDevIdx] = NULL;
	}
	*puiData[iDevIdx] = new UINT[*puiSize[iDevIdx] + 10]; 
	int iStartSamplePos = 0;
	int iMSB_Ch = 7;
	int iLSB_Ch = 0;
	if (ulaSDKGetBusData(iMSB_Ch, iLSB_Ch, *puiData[iDevIdx], puiSize[iDevIdx], iStartSamplePos) == NULL)
	{
		AfxMessageBox("Data Get Error!");
		return false;
	}
	return true;
}

BOOL CLA_SDK_CallerDlg::ShowDataOnList()
{
	GetWaveData(0);	//Device 1
	GetWaveData(1);	//Device 2
	CRect rcRect;
	this->GetDlgItem(IDC_ST_WAV)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV)->MapWindowPoints(this, rcRect);
	this->InvalidateRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV2)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV2)->MapWindowPoints(this, rcRect);
	this->InvalidateRect(rcRect);
	return true;
}

void CLA_SDK_CallerDlg::QuickGoThrough()
{
	OnBnClickedButton1();
	//OnBnClickedButton2();
	OnBnClickedButton3();
	OnBnClickedButton4();
	OnBnClickedButton5();
	OnBnClickedButton6();
	OnBnClickedButton7();
}

void CLA_SDK_CallerDlg::OnBnClickedBnStop()
{
	ulaSDKSelectDeviceIdx(0);	//ulaSDKSelectDevice("TL22360000");	
	ulaSDKStopCapture();
	ulaSDKSelectDeviceIdx(1);	//ulaSDKSelectDevice("TL22360001");	
	ulaSDKStopCapture();	
	this->GetDlgItem(IDC_BUTTON8)->EnableWindow(true);
	this->GetDlgItem(IDC_BUTTON7)->EnableWindow(true);
	ShowDataOnList();
}

void CLA_SDK_CallerDlg::OnBnClickedButton9()
{
	ulaSDKClose();
}

void CLA_SDK_CallerDlg::OnBnClickedButton10()
{
	char szFileSavePath[50];
	sprintf(szFileSavePath, "D:\\SampleFile1.law");
	ulaSDKSelectDeviceIdx(0);	//ulaSDKSelectDevice("TL22360000");	
	if (!ulaSDKSaveAsLawFile(szFileSavePath))
		MessageBox("Dev1 File Save Error");

	sprintf(szFileSavePath, "D:\\SampleFile2.law");
	ulaSDKSelectDeviceIdx(1);	//ulaSDKSelectDevice("TL22360001");	
	if (!ulaSDKSaveAsLawFile(szFileSavePath))
		MessageBox("Dev2 File Save Error");

	this->GetDlgItem(IDC_BUTTON8)->EnableWindow(true);
	this->GetDlgItem(IDC_BUTTON7)->EnableWindow(true);
}

void CLA_SDK_CallerDlg::OnBnClickedButton11()
{
	char szErrorCode[10] = {0};
	sprintf(szErrorCode, "0x%04x", ulaSDKGetLastError());

	AfxMessageBox(szErrorCode);
}

