
// LA_SDK_CallerDlg.cpp : @
//

#include "stdafx.h"
#include "LA_SDK_Caller.h"
#include "LA_SDK_CallerDlg.h"
#include "LArun.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define ID_TM_CAPTURE 150

// CLA_SDK_CallerDlg ܤ





CLA_SDK_CallerDlg::CLA_SDK_CallerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLA_SDK_CallerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pUintData = NULL;
	m_iDataLength = 0;
}
CLA_SDK_CallerDlg::~CLA_SDK_CallerDlg()
{
	if (m_pUintData != NULL)
		delete m_pUintData;
}

void CLA_SDK_CallerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CLA_SDK_CallerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, CLA_SDK_CallerDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON1, CLA_SDK_CallerDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, CLA_SDK_CallerDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, CLA_SDK_CallerDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, CLA_SDK_CallerDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, CLA_SDK_CallerDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, CLA_SDK_CallerDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, CLA_SDK_CallerDlg::OnBnClickedButton7)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON8, CLA_SDK_CallerDlg::QuickGoThrough)
	ON_BN_CLICKED(IDC_BN_STOP, CLA_SDK_CallerDlg::OnBnClickedBnStop)
	ON_BN_CLICKED(IDC_BUTTON9, CLA_SDK_CallerDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, CLA_SDK_CallerDlg::OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, CLA_SDK_CallerDlg::OnBnClickedButton11)
END_MESSAGE_MAP()


// CLA_SDK_CallerDlg TBz`

BOOL CLA_SDK_CallerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	this->SetDlgItemTextA(IDC_ED_THRESHOLD, "1600");
	this->SetDlgItemInt(IDC_ED_HWINFO, 500);	
	CRect rcRect, rcMainWnd;
	this->GetDlgItem(IDC_ST_WAV)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV)->SetWindowPos(this, 0, 0, 500, rcRect.Height(), SWP_NOZORDER | SWP_NOMOVE);
	this->GetDlgItem(IDC_ST_WAV)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV)->MapWindowPoints(this, rcRect);
	this->GetWindowRect(rcMainWnd);
	rcMainWnd.right = rcRect.right + 30;
	this->MoveWindow(rcMainWnd);
	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

// pGN̤pƫs[JzܤAzݭnUC{XA
// HKøsϥܡCϥΤ/˵Ҧ MFC ε{A
// ج[|۰ʧ@~C

void CLA_SDK_CallerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // øs˸me

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NϥܸmΤݯx
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// yøϥ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CRect rcWave;
		this->GetDlgItem(IDC_ST_WAV)->GetClientRect(rcWave);
		this->GetDlgItem(IDC_ST_WAV)->MapWindowPoints(this,rcWave);
		CPaintDC dc(this); 
		rcWave.InflateRect( 2, 2 );
		dc.DrawEdge( LPRECT(rcWave), EDGE_ETCHED, BF_RECT );
		rcWave.DeflateRect( 2, 2 );

		if( m_iDataLength <= 0 || m_pUintData == NULL)
		{
			return;
		}
		else
		{
			int		iIndex, iCnt, iCh;
			int		iH = rcWave.Height() / 9;
			int		iGap = 5;
			POINT	*ptPoly;

			ptPoly = new POINT [1000];

			// Draw CH0..CH7
			for( iCh = 0 ; iCh < 8 ; iCh++ )
			{
				for( iIndex = 0, iCnt = 0 ; iIndex < rcWave.Width() && iIndex < m_iDataLength; iIndex++ )
				{
					int iCurValue = (m_pUintData[iIndex] >> iCh) & 0x01;
					int iPreValue = 0;
					if (iIndex != 0)
						iPreValue = (m_pUintData[iIndex - 1] >> iCh) & 0x01;
					if( iIndex == 0 )
					{
						(ptPoly+iCnt)->x = 0;
						if(iCurValue) 
							(ptPoly+iCnt)->y = iCh * iH + iGap;
						else
							(ptPoly+iCnt)->y = ( iCh + 1 ) * iH - iGap;
						iCnt++;
						continue;
					}
					if( iPreValue && iCurValue )
					{
						(ptPoly+iCnt)->x = iIndex;
						(ptPoly+iCnt)->y = iCh * iH + iGap;
					}
					else if( iPreValue == 0 && iCurValue )
					{
						(ptPoly+iCnt)->x = iIndex;					//	Signal	0	1	1
						(ptPoly+iCnt)->y = (iCh + 1) * iH - iGap;	//				o	o
						iCnt++;										//			o	x<------Add one point at rising edge		
						(ptPoly+iCnt)->x = iIndex;					
						(ptPoly+iCnt)->y = iCh * iH + iGap;			
					}
					else if( iPreValue && iCurValue == 0)
					{
						(ptPoly+iCnt)->x = iIndex;					//	Signal	1	0	0
						(ptPoly+iCnt)->y = iCh * iH + iGap;			//			o	x<------Add one point at falling edge	
						iCnt++;										//				o	o
						(ptPoly+iCnt)->x = iIndex;					
						(ptPoly+iCnt)->y = ( iCh + 1 ) * iH - iGap;	
					}
					else
					{
						(ptPoly+iCnt)->x = iIndex;
						(ptPoly+iCnt)->y = ( iCh + 1 ) * iH - iGap;
					}
					iCnt++;
				}
				this->GetDlgItem(IDC_ST_WAV)->MapWindowPoints(this, ptPoly, iCnt);
				dc.Polyline( ptPoly, iCnt );
			}
			delete [] ptPoly;
		}


		CDialog::OnPaint();
	}
}

// ϥΪ̩즲̤pƵɡA
// tΩIsoӥ\oܡC
HCURSOR CLA_SDK_CallerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CLA_SDK_CallerDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	QuickGoThrough();
}


void CLA_SDK_CallerDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	if (!ulaSDKInit())
	{
		AfxMessageBox("Initial Fail");
	}

}


void CLA_SDK_CallerDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	char szBuf[10] = {0};
	sprintf(szBuf, "%x", ulaSDKGetLaID());
	AfxMessageBox(szBuf);
}


void CLA_SDK_CallerDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default
	
	ulaSDKClose();
	CDialog::OnClose();
}


void CLA_SDK_CallerDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	int iHwMode = this->GetDlgItemInt(IDC_ED_HWINFO);	

	if (!ulaSDKSetHwInfo(SET_TL_MODE, &iHwMode))
		AfxMessageBox("Hw Info Set Error!");
}


void CLA_SDK_CallerDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	CString szText;
	this->GetDlgItemText(IDC_ED_THRESHOLD, szText);
	if (!ulaSDKThreshold(0, atoi(szText)))
		AfxMessageBox("Threshould set Error!");
}


void CLA_SDK_CallerDlg::OnBnClickedButton5()
{
	// TODO: Add your control notification handler code here
	const int iTrigCondLevel = 0;
	const int iTrigCh = 2;
	const int iTrigType = LA_TRIG_RISING;
	if (ulaSDKClearTrigger(&m_SDKTrigSet))
	{
		if (ulaSDKSetChTrigger(&m_SDKTrigSet, iTrigCondLevel, iTrigCh,  iTrigType, TR_NEXT))
		{
				m_SDKTrigSet.iFlag = TR_PRETRIG;
				m_SDKTrigSet.iFreq = (INT)5E6;	//5MHz
				m_SDKTrigSet.iTrPos = 250;
				return;			
		}
	}
	AfxMessageBox("Trigger Set Build Error!");
}



void CLA_SDK_CallerDlg::OnBnClickedButton6()
{
	// TODO: Add your control notification handler code here
	int iMaxSampleNum = ulaSDKGetMaxSamplesNum();
	int iCurCaptureNum = iMaxSampleNum;
	if (iCurCaptureNum > 500)
		iCurCaptureNum = 500;
	if (!ulaSDKSetSamplesNum(iCurCaptureNum))
		AfxMessageBox("Sample Num Set Error!");
}


void CLA_SDK_CallerDlg::OnBnClickedButton7()
{
	// TODO: Add your control notification handler code here
	
	if (!ulaSDKCapture(&m_SDKTrigSet))
		AfxMessageBox("Capture Error!");
	else
	{
		this->GetDlgItem(IDC_BUTTON8)->EnableWindow(false);
		this->GetDlgItem(IDC_BUTTON7)->EnableWindow(false);
		this->GetDlgItem(IDC_BN_STOP)->EnableWindow(true);
		SetTimer(ID_TM_CAPTURE, 100, NULL);
	}
}


void CLA_SDK_CallerDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if (ulaSDKIsCaptureReady())
	{
		KillTimer(ID_TM_CAPTURE);
		ShowDataOnList();
		this->GetDlgItem(IDC_BUTTON8)->EnableWindow(true);
		this->GetDlgItem(IDC_BUTTON7)->EnableWindow(true);
		this->GetDlgItem(IDC_BN_STOP)->EnableWindow(false);
	}
	CDialog::OnTimer(nIDEvent);
}
BOOL CLA_SDK_CallerDlg::ShowDataOnList()
{
	m_iDataLength = ulaSDKGetSamplesNum();
	if (m_pUintData != NULL)
	{
		delete m_pUintData;
		m_pUintData = NULL;
	}
	m_pUintData = new UINT[m_iDataLength + 10]; 
	int iStartSamplePos = 0;
	if (ulaSDKGetBusData(7, 0, m_pUintData, &m_iDataLength, iStartSamplePos) == NULL)
	{
		AfxMessageBox("Data Get Error!");
		return false;
	}
	CRect rcRect;
	this->GetDlgItem(IDC_ST_WAV)->GetClientRect(rcRect);
	this->GetDlgItem(IDC_ST_WAV)->MapWindowPoints(this, rcRect);
	this->InvalidateRect(rcRect);

	return true;
}


void CLA_SDK_CallerDlg::QuickGoThrough()
{
	// TODO: Add your control notification handler code here
	OnBnClickedButton1();
	//OnBnClickedButton2();
	OnBnClickedButton3();
	OnBnClickedButton4();
	OnBnClickedButton5();
	OnBnClickedButton6();
	OnBnClickedButton7();
}


void CLA_SDK_CallerDlg::OnBnClickedBnStop()
{
	// TODO: Add your control notification handler code here
	if (!ulaSDKStopCapture())
		AfxMessageBox("Capture Stop Error!");
	this->GetDlgItem(IDC_BUTTON8)->EnableWindow(true);
	this->GetDlgItem(IDC_BUTTON7)->EnableWindow(true);
	ShowDataOnList();
}


void CLA_SDK_CallerDlg::OnBnClickedButton9()
{
	// TODO: Add your control notification handler code here
	ulaSDKClose();
}
void CLA_SDK_CallerDlg::OnBnClickedButton10()
{
	// TODO: Add your control notification handler code here
	char szFileSavePath[50];
	sprintf(szFileSavePath, "D:\\LaSDKSaveFolder\\SampleFile.law");
	if (!ulaSDKSaveAsLawFile(szFileSavePath))
		MessageBox("File Save Error");
	this->GetDlgItem(IDC_BUTTON8)->EnableWindow(true);
	this->GetDlgItem(IDC_BUTTON7)->EnableWindow(true);
}


void CLA_SDK_CallerDlg::OnBnClickedButton11()
{
	// TODO: Add your control notification handler code here
	char szErrorCode[10] = {0};
	sprintf(szErrorCode, "0x%04x", ulaSDKGetLastError());

	AfxMessageBox(szErrorCode);
}
